



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#设计模式之二十二访问者模式（Visitor Pattern）【行为型】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#设计模式之二十二访问者模式（Visitor Pattern）【行为型】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 08:23:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、引言</strong></p>
<p>今天我们开始讲&ldquo;行为型&rdquo;设计模式的第九个模式，该模式是【访问者模式】，英文名称是：Visitor Pattern。如果按老规矩，先从名称上来看看这个模式，我根本不能获得任何对理解该模式有用的信息，而且这个模式在我们的编码生活中使用的并不是很多。该模式的意图定义很抽象，第一次看了这个定义其实和没看没有什么区别，一头雾水，为了让大家更好的理解该模式的初衷，我们举个例子来说明模式。比如：当我们为了解决一个新的软件需求的时候，经过多个日以继夜的努力，最终通过一个完美（自己认为的）的软件设计解决了客户提出的新的需求，而且这个设计有完美的类层次结构，并且是符合OO的设计原则的，我们很开心，对自己设计的东西很有成就感。又过了一段时间，客户突然又有了一个新的需求，需要为现有的类层次结构里面的类增加一个新的操作（其实就是一个方法），怎么办？好办，在面向OO设计模式中有一个模式就是为了解决这个问题的，那就是&ldquo;访问者模式&rdquo;，可以为现有的类层次结构中的类轻松增加新的操作，我们继续吧，好好的了解一下该模式。</p>
<p><strong>二、访问者模式的详细介绍</strong></p>
<p><strong>2.1、动机（Motivate）</strong></p>
<p>在软件构建过程中，由于需求的改变，某些类层次结构中常常需要增加新的行为（方法），如果直接在基类中做这样的更改，将会给子类带来很繁重的变更负担，甚至破坏原有设计。如何在不更改类层次结构的前提下，在运行时根据需要透明地为类层次结构上的各个类动态添加新的操作，从而避免上述问题？</p>
<p><strong>2.2、意图（Intent）</strong></p>
<p>表示一个作用于某对象结构中的各个元素的操作。它可以在不改变各元素的类的前提下定义作用于这些元素的新的操作。　　　　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &mdash;&mdash;《设计模式》GoF</p>
<p><strong>2.3、结构图（Structure）</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1048776/201712/1048776-20171228123709535-1543578351.png" /></p>
<p><strong>2.4、模式的组成</strong><br />&nbsp;&nbsp; &nbsp;<br />&nbsp;&nbsp;&nbsp; 可以看出，在访问者模式的结构图有以下角色：</p>
<p><strong>（1）、抽象访问者角色（Vistor）</strong>: 声明一个包括多个访问操作，多个操作针对多个具体节点角色（可以说有多少个具体节点角色就有多少访问操作），使得所有具体访问者必须实现的接口。</p>
<p><strong>（2）、具体访问者角色（ConcreteVistor）</strong>：实现抽象访问者角色中所有声明的接口，也可以说是实现对每个具体节点角色的新的操作。</p>
<p><strong>（3）、抽象节点角色（Element）</strong>：声明一个接受操作，接受一个访问者对象作为参数，如果有其他参数，可以在这个&ldquo;接受操作&rdquo;里在定义相关的参数。</p>
<p><strong>（4）、具体节点角色（ConcreteElement）</strong>：实现抽象元素所规定的接受操作。</p>
<p><strong>（5）、结构对象角色（ObjectStructure）</strong>：节点的容器，可以包含多个不同类或接口的容器。</p>
<p><strong>2.5、访问者模式的代码实现</strong></p>
<p>访问者这个模式在我们现实的编码生活中使用的并不是很多，我就直接贴代码，让大家看代码的结构吧。今天给大家两个代码实例，自己慢慢体会访问者吧。实现代码如下：</p>
<div>
<pre class="prettyprint linenums"> namespace Vistor<br />
 {<br />
     //抽象图形定义---相当于&ldquo;抽象节点角色&rdquo;Element<br />
     public abstract class Shape<br />
     {<br />
         //画图形<br />
         public abstract void Draw();<br />
         //外界注入具体访问者<br />
         public abstract void Accept(ShapeVisitor visitor);<br />
     }

     //抽象访问者 Visitor<br />
     public abstract class ShapeVisitor<br />
     {<br />
         public abstract void Visit(Rectangle shape);

         public abstract void Visit(Circle shape);

         public abstract void Visit(Line shape);

         //这里有一点要说：Visit方法的参数可以写成Shape吗？就是这样 Visit(Shape shape)，当然可以，但是ShapeVisitor子类Visit方法就需要判断当前的Shape是什么类型，是Rectangle类型，是Circle类型，或者是Line类型。<br />
     }

     //具体访问者 ConcreteVisitor<br />
     public sealed class CustomVisitor : ShapeVisitor<br />
     {<br />
         //针对Rectangle对象<br />
         public override void Visit(Rectangle shape)<br />
         {<br />
             Console.WriteLine("针对Rectangle新的操作！");<br />
         }<br />
         //针对Circle对象<br />
         public override void Visit(Circle shape)<br />
         {<br />
             Console.WriteLine("针对Circle新的操作！");<br />
         }<br />
         //针对Line对象<br />
         public override void Visit(Line shape)<br />
         {<br />
             Console.WriteLine("针对Line新的操作！");<br />
         }<br />
     }

     //矩形----相当于&ldquo;具体节点角色&rdquo; ConcreteElement<br />
     public sealed class Rectangle : Shape<br />
     {<br />
         public override void Draw()<br />
         {<br />
             Console.WriteLine("矩形我已经画好！");<br />
         }

         public override void Accept(ShapeVisitor visitor)<br />
         {<br />
             visitor.Visit(this);<br />
         }<br />
     }

     //圆形---相当于&ldquo;具体节点角色&rdquo;ConcreteElement<br />
     public sealed class Circle : Shape<br />
     {<br />
         public override void Draw()<br />
         {<br />
             Console.WriteLine("圆形我已经画好！");<br />
         }

         public override void Accept(ShapeVisitor visitor)<br />
         {<br />
             visitor.Visit(this);<br />
         }<br />
     }

     //直线---相当于&ldquo;具体节点角色&rdquo; ConcreteElement<br />
     public sealed class Line : Shape<br />
     {<br />
         public override void Draw()<br />
         {<br />
             Console.WriteLine("直线我已经画好！");<br />
         }

         public override void Accept(ShapeVisitor visitor)<br />
         {<br />
             visitor.Visit(this);<br />
         }<br />
     }

     //结构对象角色<br />
     internal class AppStructure<br />
     {<br />
         private ShapeVisitor _visitor;

         public AppStructure(ShapeVisitor visitor)<br />
         {<br />
             this._visitor = visitor;<br />
         }

         public void Process(Shape shape)<br />
         {<br />
             shape.Accept(_visitor);<br />
         }<br />
     }

     class Program<br />
     {<br />
         static void Main(string[] args)<br />
         {<br />
             //如果想执行新增加的操作<br />
             ShapeVisitor visitor = new CustomVisitor();<br />
             AppStructure app = new AppStructure(visitor);

             Shape shape = new Rectangle();<br />
             shape.Draw();//执行自己的操作<br />
             app.Process(shape);//执行新的操作

             shape = new Circle();<br />
             shape.Draw();//执行自己的操作<br />
             app.Process(shape);//执行新的操作

             shape = new Line();<br />
             shape.Draw();//执行自己的操作<br />
             app.Process(shape);//执行新的操作

             Console.ReadLine();<br />
         }<br />
     }<br />
 }</pre>
</div>
<p>这是访问者模式第二种代码实例：</p>
<div>
<pre class="prettyprint linenums"> namespace Visitor<br />
 {<br />
     //抽象访问者角色 Visitor<br />
     public abstract class Visitor<br />
     {<br />
         public abstract void PutTelevision(Television tv);

         public abstract void PutComputer(Computer comp);<br />
     }

     //具体访问者角色 ConcreteVisitor<br />
     public sealed class SizeVisitor : Visitor<br />
     {<br />
         public override void PutTelevision(Television tv)<br />
         {<br />
             Console.WriteLine("按商品大小{0}排放", tv.Size);<br />
         }

         public override void PutComputer(Computer comp)<br />
         {<br />
             Console.WriteLine("按商品大小{0}排放", comp.Size);<br />
         }<br />
     }

     //具体访问者角色 ConcreteVisitor<br />
     public sealed class StateVisitor : Visitor<br />
     {<br />
         public override void PutTelevision(Television tv)<br />
         {<br />
             Console.WriteLine("按商品新旧值{0}排放", tv.State);<br />
         }

         public override void PutComputer(Computer comp)<br />
         {<br />
             Console.WriteLine("按商品新旧值{0}排放", comp.State);<br />
         }<br />
     }

     //抽象节点角色 Element<br />
     public abstract class Goods<br />
     {<br />
         public abstract void Operate(Visitor visitor);

         private int nSize;<br />
         public int Size<br />
         {<br />
             get { return nSize; }<br />
             set { nSize = value; }<br />
         }

         private int nState;<br />
         public int State<br />
         {<br />
             get { return nState; }<br />
             set { nState = value; }<br />
         }<br />
     }

     //具体节点角色 ConcreteElement<br />
     public sealed class Television : Goods<br />
     {<br />
         public override void Operate(Visitor visitor)<br />
         {<br />
             visitor.PutTelevision(this);<br />
         }<br />
     }

     //具体节点角色 ConcreteElement<br />
     public sealed class Computer : Goods<br />
     {<br />
         public override void Operate(Visitor visitor)<br />
         {<br />
             visitor.PutComputer(this);<br />
         }<br />
     }

     //结构对象角色<br />
     public sealed class StoragePlatform<br />
     {<br />
         private IList&lt;Goods&gt; list = new List&lt;Goods&gt;();

         public void Attach(Goods element)<br />
         {<br />
             list.Add(element);<br />
         }

         public void Detach(Goods element)<br />
         {<br />
             list.Remove(element);<br />
         }

         public void Operate(Visitor visitor)<br />
         {<br />
             foreach (Goods g in list)<br />
             {<br />
                 g.Operate(visitor);<br />
             }<br />
         }<br />
     }

     class Program<br />
     {<br />
         static void Main(string[] args)<br />
         {<br />
             StoragePlatform platform = new StoragePlatform();<br />
             platform.Attach(new Television());<br />
             platform.Attach(new Computer());

             SizeVisitor sizeVisitor = new SizeVisitor();<br />
             StateVisitor stateVisitor = new StateVisitor();

             platform.Operate(sizeVisitor);<br />
             platform.Operate(stateVisitor);

             Console.Read();<br />
         }<br />
     }<br />
 }</pre>
</div>
<p><strong>三、访问者模式的实现要点：</strong></p>
<p>Visitor模式通过所谓双重分发（double dispatch）来实现在不更改Element类层次结构的前提下，在运行时透明地为类层次结构上的各个类动态添加新的操作。所谓双重分发即Visitor模式中间包括了两个多态分发（注意其中的多态机制）：第一个为accept方法的多态辨析；第二个为visit方法的多态辨析。</p>
<p>　　设计模式其实是一种堵漏洞的方式，但是没有一种设计模式能够堵完所有的漏洞，即使是组合各种设计模式也是一样。每个设计模式都有漏洞，都有它们解决不了的情况或者变化。每一种设计模式都假定了某种变化，也假定了某种不变化。Visitor模式假定的就是操作变化，而Element类层次结构稳定。</p>
<p><strong>（1）、访问者模式的主要优点有：</strong></p>
<p>1】、访问者模式使得添加新的操作变得容易。如果一些操作依赖于一个复杂的结构对象的话，那么一般而言，添加新的操作会变得很复杂。而使用访问者模式，增加新的操作就意味着添加一个新的访问者类。因此，使得添加新的操作变得容易。</p>
<p>2】、访问者模式使得有关的行为操作集中到一个访问者对象中，而不是分散到一个个的元素类中。这点类似与&rdquo;中介者模式&rdquo;。</p>
<p>3】、访问者模式可以访问属于不同的等级结构的成员对象，而迭代只能访问属于同一个等级结构的成员对象。</p>
<p>　<strong>（2）、访问者模式的主要缺点有：</strong></p>
<p>1】、增加新的元素类变得困难。每增加一个新的元素意味着要在抽象访问者角色中增加一个新的抽象操作，并在每一个具体访问者类中添加相应的具体操作。具体来说，Visitor模式的最大缺点在于扩展类层次结构（增添新的Element子类），会导致Visitor类的改变。因此Visitor模式适用于&ldquo;Element类层次结构稳定，而其中的操作却经常面临频繁改动&rdquo;。</p>
<p><strong>（3）、在下面的情况下可以考虑使用访问者模式：</strong></p>
<p>1】、如果系统有比较稳定的数据结构，而又有易于变化的算法时，此时可以考虑使用访问者模式。因为访问者模式使得算法操作的添加比较容易。</p>
<p>2】、如果一组类中，存在着相似的操作，为了避免出现大量重复的代码，可以考虑把重复的操作封装到访问者中。（当然也可以考虑使用抽象类了）</p>
<p>3】、如果一个对象存在着一些与本身对象不相干，或关系比较弱的操作时，为了避免操作污染这个对象，则可以考虑把这些操作封装到访问者对象中。</p>
<p><strong>四、.NET 访问者模式的实现</strong></p>
<p>在现在的Net框架里面，如果要想给现有的类增加新的方法，有了新的方式，那就是&ldquo;扩展方法&rdquo;，使用起来和实例方法是一样一样的，而且在Net框架里面，微软自己也写了很多的扩展方法给我们使用。我目前还没有学习到Net的框架类库里面有&ldquo;访问者模式&rdquo;实现，看来自己还需努力，革命尚未成功啊。</p>
<p><strong>五、总结</strong></p>
<p>访问者模式写完了，这个模式刚开始理解起来还是挺麻烦的，但是，如果我们多看几个实例代码，完全掌握也不是问题。随着C#语言的发展，设计模式里面的很多东西，我们可以通过C#语言的一些特性做更好的替代。我们写设计模式刚开始要慢慢来，一步一步的照猫画虎的来写代码，等我们熟练掌握了模式的核心意思，我们就要写符合C#风格和特性的模式代码了，或者说我们要用C#来写设计模式了，写出来的代码会更棒。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zonz3q.html">Poj2676</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5p1gq.html">查找n个数字中的最大值</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xjljz8.html">在调用&OpenCurlyDoubleQuote;Fill&rdquo;前，SelectCommand 属性尚未初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdpgdd8.html">jni cocos2d-x移植到android：helloworld</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd75k2q.html">Java学习日记-5 关键字static和final 以及接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrnez8.html">【JAVAWEB学习笔记】22&lowbar;ajax</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z321x9.html">【编程技巧】applicationContext&period;xml 里面可配置bean和数据库地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z34pk9.html">百度地图、高德地图、Google地图等坐标系相关梳理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3g0k9.html">mysql索引sql优化方法、步骤和经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zr45k9.html">QMQTT简单介绍（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp73vj9.html">一道Python面试题：给出d &equals; &lbrack;True&comma; False&comma; True&comma; False&comma; True&rsqb;，请利用列表d，只用一句话返回列表&lbrack;0&comma;2&comma;4&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodzldq.html">Asp&period;Net登陆记住用户功能实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4eprz9.html">20175224 2018-2019-2 《Java程序设计》第六周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll7o0q.html">【spring boot】idea下springboot打包成jar包和war包，并且可以在外部tomcat下运行访问到&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1mxv49.html">vue原理简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7orzwg8.html">php安装及配置笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r637j9.html">spring boot js 文件引用 单引问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy50en9.html">python 遇到的一些坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnn553q.html">DLL中导出函数的两种方式&lpar;dllexport与&period;def文件&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnlmygq.html">java 数字转中文</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwj4mok8.html">update and的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv13ymjq.html">tsung压力测试&mdash;&mdash;tcp测试tsung&period;xml配置模版说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljp6jx9.html">jquery总结（来自于一个讲师的总结）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljpgex9.html">work     2013-07-19</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd207y9.html">Jenkins与网站代码上线解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kw0x09.html">MyBatis物理分页的代码实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ger2wz8.html">css一些简单的例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpx0oxq.html">（翻译）使用Api分析器与Windows兼容包来编写智能的跨平台&period;NET Core应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdvdv79.html">使用Xamarin开发手机聊天程序 -- 基础篇（大量图文讲解 step by step，附源码下载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ngd08.html">C&num;  &lpar;using Newtonsoft&period;Json&rpar;  Json 转换用法小总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
